<?php

//Get the current options create empty ones if they don't exist.
$connect_phpbb_options =  get_option('connect_phpbb_options');
if($connect_phpbb_options == ''){
	$connect_phpbb_options = array('path' => '');
}

$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=phpbb-single-sign-on/options.php';

//POST : Check if there are new options set
if ('process' == $_POST['stage']) {
    $new_options = array();

    foreach($connect_phpbb_options as $key => $option){
        $new_options[$key] = $_POST[strtolower($key)];
    }

    update_option('connect_phpbb_options', $new_options);
    $connect_phpbb_options = $new_options;
}


//Get the paths
if ( !defined('ABSPATH') ){
	define('ABSPATH', (dirname(dirname(dirname(dirname(__FILE__))))) . '/');
}
	
if(!defined('PHPBBPATH')){
	if($connect_phpbb_options['path'] != ''){
		define('PHPBBPATH',$connect_phpbb_options['path']);
	} else {
		define('PHPBBPATH','forum/');
	}
}

//prepare the paths to the folders and files
$config_files = array(
	'auth_op' => array(
		'source' => dirname(__FILE__).'/files/auth_op.php',
		'destin' => ABSPATH.PHPBBPATH.'includes/auth/auth_op.php',
		'folder' => ABSPATH.PHPBBPATH.'includes/auth'
		),
	'common' => array(
		'source' => dirname(__FILE__).'/files/common.php',
		'destin' => ABSPATH.PHPBBPATH.'common.php',
		'folder' => ABSPATH.PHPBBPATH
		),
	'common.orig' => array(
		'destin' => ABSPATH.PHPBBPATH.'common.orig.php',
		)
	);

function get_file_version($file)
{
	if(file_exists($file)){
		$content = file_get_contents($file);
		if(strpos($content, '@version $Id: common.php') !== false){
			return "Original";
		}
		preg_match('/@version\s([0-9.]+)/',$content,$version);
		return $version[1];
	} else {
		return 0;
	}
}

//POST : Install the plugin
if('install' == $_POST['stage']){
	//echo 'bla bla';
	// if the folder is writable
	if(is_writable($config_files['auth_op']['folder'])){
		//the file is already installed
		if(!file_exists($config_files['auth_op']['destin'])){
			
			
			copy($config_files['auth_op']['source'],$config_files['auth_op']['destin']);
			
			$helptxt = '<p><strong>Success</strong>: The phpBB module was activated.  The phpBB authentication library has been successfully added to your phpBB install.</p>';
			$helptxt .= '<p>To activate the library in phpBB, log into the administration center for phpBB and activate the "Op" authentication method.<br/>This setting is located at: <strong>"Client Communication" &raquo; "Authentication" &raquo; "Select an authentication method" &raquo; "Op"</strong><br/>Note: Leave all fields blank and click submit to activate OP authentication.</p>';
		} else {
			unlink($config_files['auth_op']['destin']);
			if(copy($config_files['auth_op']['source'],$config_files['auth_op']['destin'])){
				$helptxt = 'Upgrade Successful for auth_op.php';
			}
		}
	//if the file isn't writable
	} else {
		$helptxt = '<p><strong>Error</strong>: The phpBB module was <strong>not</strong> activated.  The phpBB authentication library was <strong>not</strong> successfully added to your phpBB install.<br/>The directory, <i>'.ABSPATH.PHPBBPATH.'includes/auth/</i>, must be writeable.<br/><br/>Upon making these changes, you may attempt to reactivate this module.<br/><br/>You may also manually copy the file located at <i>'.TEMPLATEPATH.'/phpbb/auth_op.php</i> to the destination folder.</p>';
	}
	
	if(is_writable($config_files['common']['folder'])){
		//is original file ?
		if(get_file_version($config_files['common']['destin']) == 'Original') {
			//is original file there ?
			if(file_exists($config_files['common.orig']['destin'])){
				unlink($config_files['common.orig']['destin']);
			} 
			//put the original file there
			copy($config_files['common']['destin'],$config_files['common.orig']['destin']);
		}
		
		//in all cases, install the file
		//is the file there ?
		if(file_exists($config_files['common']['destin'])){
			unlink($config_files['common']['destin']);
		} 
		copy($config_files['common']['source'],$config_files['common']['destin']);
		
		$helptxt .= 'Upgrade Successful for common.php';
		
	} else {
		$helptxt .= '<p><strong>Error</strong>: The phpBB module was <strong>not</strong> activated.  The phpBB authentication library was <strong>not</strong> successfully added to your phpBB install.<br/>The directory, <i>'.ABSPATH.PHPBBPATH.'/</i>, must be writeable.<br/><br/>Upon making these changes, you may attempt to reactivate this module.<br/><br/>You may also manually copy the file located at <i>'.TEMPLATEPATH.'/phpbb/auth_op.php</i> to the destination folder.</p>';
	}
	
}

?>
<div class="wrap">
  <h2><?php _e('PHP BB Options', 'PHPBB') ?></h2>
  <form name="form1" method="post" action="<?php echo $options_page ?>&amp;updated=true">
	<input type="hidden" name="stage" value="process" />
    <table width="100%" cellspacing="2" cellpadding="5" class="form-table">

	<tr valign="baseline">
	    <th scope="row"><?php _e('Path', 'phpbb') ?></th>
	    <td>
	        <input type="text" value="<?php echo $connect_phpbb_options['path'] ?>" name="path" />
	        <div><small><?php _e('Path to the forum from the root of Wordpress', 'phpbb') ?></small></div>
	    </td>
	</tr>

	</table>
    <p class="submit">
      <input type="submit" name="Submit" value="<?php _e('Save Changes', 'phpbb') ?>" />
    </p>
  </form>
  
  <form name="form2" method="post" action="<?php echo $options_page ?>">
	<input type="hidden" name="stage" value="install" />

	
	
	<?php if(!isset($helptxt)) { ?>
	<p>To activate the library in phpBB, log into the administration center for phpBB and activate the "Op" authentication method.<br/>This setting is located at: <strong>"Client Communication" &raquo; "Authentication" &raquo; "Select an authentication method" &raquo; "Op"</strong><br/>Note: Leave all fields blank and click submit to activate OP authentication.</p>
	<?php } else { 
		echo $helptxt;
	 } ?>
	
	<table>
		<tr>
			<th>&nbsp;</th>
			<th>Latest</th>
			<th>Installed</th>
		</tr>
		<tr>
			<td>auth_op.php</th>
			<td><?php echo get_file_version($config_files['auth_op']['source']); ?></td>
			<td><?php echo get_file_version($config_files['auth_op']['destin']); ?></td>
		</tr>
		<tr>
			<td>common.php</th>
			<td><?php echo get_file_version($config_files['common']['source']); ?></td>
			<td><?php echo get_file_version($config_files['common']['destin']); ?></td>
		</tr>
		<tr>
			<td>common.orig.php</th>
			<td>-</td>
			<td><?php echo get_file_version($config_files['common.orig']['destin']); ?></td>
		</tr>
	</table>
	
	
    <p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Install Files in PHP BB', 'phpbb') ?>" /> 
    </p>
  </form>
</div>